local mod = ...



-- Asset -------------------------------------------------------------------------------------
mod:registerAssetId("models/Authority2.fbx/Prefab/ExchequerMaleHat", "PREFAB_AUTHORITY_EXCHEQUER_MALE_HAT")
mod:registerAssetId("models/Authority2.fbx/Prefab/ExchequerMaleBelt", "PREFAB_AUTHORITY_EXCHEQUER_MALE_BELT")
mod:registerAssetId("models/Authority2.fbx/Prefab/ExchequerMaleFront", "PREFAB_AUTHORITY_EXCHEQUER_MALE_FRONT")

mod:registerAssetId("models/Authority2.fbx/Prefab/ExchequerFemaleHat", "PREFAB_AUTHORITY_EXCHEQUER_FEMALE_HAT")
mod:registerAssetId("models/Authority2.fbx/Prefab/ExchequerFemaleFront", "PREFAB_AUTHORITY_EXCHEQUER_FEMALE_FRONT") -- costume attached to the front disappears when a character carries a crate, and doesn't come back until the game is reloaded
mod:registerAssetId("models/Authority2.fbx/Prefab/ExchequerFemaleBelt", "PREFAB_AUTHORITY_EXCHEQUER_FEMALE_BELT")

mod:registerAssetId("models/Authority2.fbx/Prefab/ExchequerAssistantMaleHat", "PREFAB_AUTHORITY_EXCHEQUER_ASSISTANT_MALE_HAT")
mod:registerAssetId("models/Authority2.fbx/Prefab/ExchequerAssistantFemaleHat", "PREFAB_AUTHORITY_EXCHEQUER_ASSISTANT_FEMALE_HAT")



-- Job: Exchequer -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_AUTHORITY_EXCHEQUER",
	JobName = "JOB_AUTHORITY_EXCHEQUER_NAME",
	JobDescription = "JOB_AUTHORITY_EXCHEQUER_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_WORK",
    ProductionDelay = 60.0,
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
        -- RightHandObject = {
		-- 	DataType = "HAND_OBJECT",
        --     Model = "PREFAB_TOOL_GUARD_SPEAR"
        -- },
        -- MaleClothingModel = {
        --     "PREFAB_AUTHORITY_BLANK",
        -- },
        MaleHatList = {
            "PREFAB_AUTHORITY_EXCHEQUER_MALE_HAT",
        }, 
        MaleBeltList = {
            "PREFAB_AUTHORITY_EXCHEQUER_MALE_BELT",
        },
        MaleFrontList = {
            "PREFAB_AUTHORITY_EXCHEQUER_MALE_FRONT",
        },
        -- FemaleClothingModel = {
        --     "PREFAB_AUTHORITY_BLANK",
        -- },
        FemaleHatList = {
            "PREFAB_AUTHORITY_EXCHEQUER_FEMALE_HAT",
        }, 
        FemaleFrontList = {
            "PREFAB_AUTHORITY_EXCHEQUER_FEMALE_FRONT",
        }, 
        FemaleBeltList = {
            "PREFAB_AUTHORITY_EXCHEQUER_FEMALE_BELT",
        },
		WalkAnimation = "WALKING",
		IdleAnimation = "IDLE"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_AUTHORITY_EXCHEQUER"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_AUTHORITY_EXCHEQUER"
    }
})

mod:override({
    Id = "COMMONER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_AUTHORITY_EXCHEQUER"
    }
})

mod:override({
    Id = "CITIZEN",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_AUTHORITY_EXCHEQUER"
    }
})



-- Job: Exchequer's Assistant -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_AUTHORITY_EXCHEQUER_ASSISTANT",
	JobName = "JOB_AUTHORITY_EXCHEQUER_ASSISTANT_NAME",
	JobDescription = "JOB_AUTHORITY_EXCHEQUER_ASSISTANT_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_WORK",
    ProductionDelay = 10.0,
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
        MaleHatList = {
            "PREFAB_AUTHORITY_EXCHEQUER_ASSISTANT_MALE_HAT",
        }, 
        FemaleHatList = {
            "PREFAB_AUTHORITY_EXCHEQUER_ASSISTANT_FEMALE_HAT",
        }, 
		WalkAnimation = "WALKING",
		IdleAnimation = "IDLE"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_AUTHORITY_EXCHEQUER_ASSISTANT"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_AUTHORITY_EXCHEQUER_ASSISTANT"
    }
})

mod:override({
    Id = "COMMONER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_AUTHORITY_EXCHEQUER_ASSISTANT"
    }
})

mod:override({
    Id = "CITIZEN",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_AUTHORITY_EXCHEQUER_ASSISTANT"
    }
})



-- Resource: Directive (Exchequer) -------------------------------------------------------------------------------------
mod:registerAssetId("icons/DirectiveExchequer.png", "ICON_DIRECTIVE_EXCHEQUER")

mod:register({
	DataType = "RESOURCE",
	Id = "RESOURCE_DIRECTIVE_EXCHEQUER",
	ResourceName = "RESOURCE_DIRECTIVE_EXCHEQUER_NAME",
	Icon = "ICON_DIRECTIVE_EXCHEQUER",
	ResourceTypeList = { "RESOURCE_TYPE_AUTHORITY" },
	IsTradable = false,
    DisplayInInventory = false,
	DisplayInToolbar = false,
	OrderId = 0
})



-- Resource: Wage -------------------------------------------------------------------------------------
mod:registerAssetId("icons/Wage.png", "ICON_WAGE")

mod:register({
	DataType = "RESOURCE",
	Id = "RESOURCE_WAGE",
	ResourceName = "RESOURCE_WAGE_NAME",
	Icon = "ICON_WAGE",
	ResourceTypeList = { "RESOURCE_TYPE_AUTHORITY" },
	IsTradable = false,
    DisplayInInventory = false,
	DisplayInToolbar = false,
	OrderId = 0
})



-- Building Function: Exchequer -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_AUTHORITY_EXCHEQUER",
	Name = "BUILDING_FUNCTION_AUTHORITY_EXCHEQUER_NAME",
	HasMaximumInstance = true,
	MaximumInstanceAllowed = 1,
	WorkerCapacity = 1,
	UpkeepPerWorker = {
		{
			Resource = "GOLD_COINS",
			Quantity = 10
		}
	},
    RelatedJob = { 
        Job = "JOB_AUTHORITY_EXCHEQUER", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
	},
    ResourceListNeeded = {
	},
	ResourceProduced = {
        { Resource = "RESOURCE_DIRECTIVE_EXCHEQUER", Quantity = 5 },
    }
})



-- Building Function: Exchequer's Assistant -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_AUTHORITY_EXCHEQUER_ASSISTANT",
	Name = "BUILDING_FUNCTION_AUTHORITY_EXCHEQUER_ASSISTANT_NAME",
	HasMaximumInstance = true,
	MaximumInstanceAllowed = 1,
	WorkerCapacity = 3,
	UpkeepPerWorker = {
		{
			Resource = "GOLD_COINS",
			Quantity = 2
		}
	},
    RelatedJob = { 
        Job = "JOB_AUTHORITY_EXCHEQUER_ASSISTANT", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
        { Resource = "GOLD_COINS", Quantity = 50 },
        { Resource = "RESOURCE_DIRECTIVE_EXCHEQUER", Quantity = 10 },
	},
    ResourceListNeeded = {
        { Resource = "GOLD_COINS", Quantity = 5 },
        { Resource = "RESOURCE_DIRECTIVE_EXCHEQUER", Quantity = 1 },
	},
	ResourceProduced = {
        { Resource = "RESOURCE_WAGE", Quantity = 5 },
    }
})



-- Building Function List: Lord Manor (OVERRIDE) -------------------------------------------------------------------------------------
mod:override({
	Id = "BUILDING_FUNCTION_LIST_LORD_MANOR",
	AssetFunctionList = {
		Action = "APPEND",
		"BUILDING_FUNCTION_AUTHORITY_EXCHEQUER"
	}
})



-- Building Function List: Assistants -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_LIST",
    Id = "BUILDING_FUNCTION_LIST_AUTHORITY_ASSISTANT",
	AssetFunctionList = {
		"BUILDING_FUNCTION_AUTHORITY_EXCHEQUER_ASSISTANT",
		"BUILDING_FUNCTION_AUTHORITY_COUNCIL_ASSISTANT",
		"BUILDING_FUNCTION_AUTHORITY_CHANCERY_ASSISTANT",
	}
})



-- Building Function Assignable: Storage Chamber -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_ASSIGNABLE",
    Id = "BUILDING_FUNCTION_ASSIGNABLE_AUTHORITY_ASSISTANT",
    AuthorizedFunctionList = "BUILDING_FUNCTION_LIST_AUTHORITY_ASSISTANT"
})


